From be4ceecd9876a34052fa0c74887e67d115d7f730 Mon Sep 17 00:00:00 2001
From: Adam Young <ayoung@redhat.com>
Date: Tue, 2 Aug 2011 16:19:59 -0400
Subject: [PATCH] eclipse project files

This contains only the files necessary to get the project to import into Eclipse,  plus a very small .gitignore file for people that want to use git svn.  This patch should have no effects on the way that code currently runs.

The difference between this patch and the previous submission is that this one does not attempt to deal with the problems due to the code duplication between the console and common code bases:  it does not include the console in the classpath.  People that want to use eclipse to work with the console will have to perform additional modifications.  Also, it does not include the  directory base/common/test  that has abstract classes
---
 .classpath |   34 ++++++++++++++++++++++++++++++++++
 .gitignore |    4 ++++
 .project   |   17 +++++++++++++++++
 3 files changed, 55 insertions(+), 0 deletions(-)
 create mode 100644 .classpath
 create mode 100644 .gitignore
 create mode 100644 .project

diff --git a/.classpath b/.classpath
new file mode 100644
index 0000000000000000000000000000000000000000..891959cbce834c1cbe791b1dafa754640d7a7068
--- /dev/null
+++ b/.classpath
@@ -0,0 +1,34 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<classpath>
+	<classpathentry kind="src" path="base/ca/src"/>
+	<classpathentry kind="src" path="base/common/src"/>
+	<classpathentry kind="src" path="base/java-tools/src"/>
+	<classpathentry kind="src" path="base/kra/src"/>
+	<classpathentry kind="src" path="base/migrate/80"/>
+	<classpathentry kind="src" path="base/ocsp/src"/>
+	<classpathentry kind="src" path="base/silent/src/argparser"/>
+	<classpathentry kind="src" path="base/silent/src/ca"/>
+	<classpathentry kind="src" path="base/silent/src/common"/>
+	<classpathentry kind="src" path="base/silent/src/drm"/>
+	<classpathentry kind="src" path="base/silent/src/http"/>
+	<classpathentry kind="src" path="base/silent/src/ocsp"/>
+	<classpathentry kind="src" path="base/silent/src/ra"/>
+	<classpathentry kind="src" path="base/silent/src/subca"/>
+	<classpathentry kind="src" path="base/silent/src/tks"/>
+	<classpathentry kind="src" path="base/silent/src/tps"/>
+	<classpathentry kind="src" path="base/symkey/src"/>
+	<classpathentry kind="src" path="base/tks/src"/>
+	<classpathentry kind="src" path="base/util/src"/>
+	<classpathentry kind="con" path="org.eclipse.jdt.launching.JRE_CONTAINER"/>
+	<classpathentry kind="lib" path="/usr/share/java/idm-console-mcc.jar"/>
+	<classpathentry kind="lib" path="/usr/share/java/idm-console-base.jar"/>
+	<classpathentry kind="lib" path="/usr/share/java/ldapjdk.jar"/>
+	<classpathentry kind="lib" path="/usr/share/java/idm-console-nmclf.jar"/>
+	<classpathentry kind="lib" path="/usr/lib/java/jss4.jar"/>
+	<classpathentry kind="lib" path="/usr/lib/java/osutil.jar"/>
+	<classpathentry kind="lib" path="/usr/share/java/velocity.jar"/>
+	<classpathentry kind="lib" path="/usr/share/java/servlet.jar"/>
+	<classpathentry kind="lib" path="/usr/share/java/xerces-j2.jar"/>
+	<classpathentry kind="lib" path="/usr/share/java/junit4.jar"/>
+	<classpathentry kind="output" path="build/classes"/>
+</classpath>
diff --git a/.gitignore b/.gitignore
new file mode 100644
index 0000000000000000000000000000000000000000..e452d956254c37d929b8e8a6a7d1994561089c7a
--- /dev/null
+++ b/.gitignore
@@ -0,0 +1,4 @@
+build/
+base/migrate/kra/RecoverKey.class
+base/migrate/kra/RecoverPin.class
+
diff --git a/.project b/.project
new file mode 100644
index 0000000000000000000000000000000000000000..cc1a7216a20761d014484187423fc5c40d1e8802
--- /dev/null
+++ b/.project
@@ -0,0 +1,17 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<projectDescription>
+	<name>pki</name>
+	<comment></comment>
+	<projects>
+	</projects>
+	<buildSpec>
+		<buildCommand>
+			<name>org.eclipse.jdt.core.javabuilder</name>
+			<arguments>
+			</arguments>
+		</buildCommand>
+	</buildSpec>
+	<natures>
+		<nature>org.eclipse.jdt.core.javanature</nature>
+	</natures>
+</projectDescription>
-- 
1.7.6